// Verilated -*- C++ -*-
// DESCRIPTION: Verilator output: Model implementation (design independent parts)

#include "Vsecret_impl.h"
#include "Vsecret_impl_PSKFfQ.h"

//============================================================
// Constructors

Vsecret_impl::Vsecret_impl(VerilatedContext* _vcontextp__, const char* _vcname__)
    : VerilatedModel{*_vcontextp__}
    , vlSymsp{new Vsecret_impl_PSKFfQ(contextp(), _vcname__, this)}
    , clk{vlSymsp->TOP.clk}
    , a{vlSymsp->TOP.a}
    , b{vlSymsp->TOP.b}
    , x{vlSymsp->TOP.x}
    , rootp{&(vlSymsp->TOP)}
{
    // Register model with the context
    contextp()->addModel(this);
}

Vsecret_impl::Vsecret_impl(const char* _vcname__)
    : Vsecret_impl(Verilated::threadContextp(), _vcname__)
{
}

//============================================================
// Destructor

Vsecret_impl::~Vsecret_impl() {
    delete vlSymsp;
}

//============================================================
// Evaluation loop

void Vsecret_impl_PSuPuT__PSOA3q(Vsecret_impl_PSuPuT* vlSelf);
void Vsecret_impl_PSuPuT__PSNy8w(Vsecret_impl_PSuPuT* vlSelf);
void Vsecret_impl_PSuPuT__PSjFjA(Vsecret_impl_PSuPuT* vlSelf);
#ifdef VL_DEBUG
void Vsecret_impl_PSuPuT__PSLEa2(Vsecret_impl_PSuPuT* vlSelf);
#endif  // VL_DEBUG
void Vsecret_impl_PSuPuT__PSC03A(Vsecret_impl_PSuPuT* vlSelf);

static void PSjjw5(Vsecret_impl_PSKFfQ* __restrict vlSymsp) {
    vlSymsp->__Vm_didInit = true;
    Vsecret_impl_PSuPuT__PSOA3q(&(vlSymsp->TOP));
    // Evaluate till stable
    do {
        VL_DEBUG_IF(VL_DBG_MSGF("+ Initial loop\n"););
        Vsecret_impl_PSuPuT__PSNy8w(&(vlSymsp->TOP));
        Vsecret_impl_PSuPuT__PSjFjA(&(vlSymsp->TOP));
    } while (0);
}

void Vsecret_impl::eval_step() {
    VL_DEBUG_IF(VL_DBG_MSGF("+++++TOP Evaluate Vsecret_impl::eval_step\n"); );
#ifdef VL_DEBUG
    // Debug assertions
    Vsecret_impl_PSuPuT__PSLEa2(&(vlSymsp->TOP));
#endif  // VL_DEBUG
    // Initialize
    if (VL_UNLIKELY(!vlSymsp->__Vm_didInit)) PSjjw5(vlSymsp);
    // Evaluate till stable
    do {
        VL_DEBUG_IF(VL_DBG_MSGF("+ Clock loop\n"););
        Vsecret_impl_PSuPuT__PSjFjA(&(vlSymsp->TOP));
    } while (0);
    // Evaluate cleanup
}

//============================================================
// Utilities

const char* Vsecret_impl::name() const {
    return vlSymsp->name();
}

//============================================================
// Invoke final blocks

VL_ATTR_COLD void Vsecret_impl::final() {
    Vsecret_impl_PSuPuT__PSC03A(&(vlSymsp->TOP));
}

//============================================================
// Implementations of abstract methods from VerilatedModel

const char* Vsecret_impl::hierName() const { return vlSymsp->name(); }
const char* Vsecret_impl::modelName() const { return "Vsecret_impl"; }
unsigned Vsecret_impl::threads() const { return 1; }
